library ieee;
use ieee.std_logic_1164.all;

entity alu is
  port (a,b: in integer;
        op: in integer range 0 to 3;
        ris: out integer;
        zero,segno: out boolean);
end alu;

architecture beh of alu is
 
 procedure exe_alu ( signal a: in integer; signal b: in integer; signal op : in integer range 0 to 3; signal r: out integer; signal zero: out boolean; signal segno: out boolean)
  is
  variable tris: integer;
  begin
    case op is
    when 0 =>  tris:= a+b;
    when 1 =>  tris:= a-b;
    when 2 =>  tris:= a*b;
    when 3 =>  tris:= a/b;
  end case;
  if tris = 0 then zero<= true;
       else zero<= false;
  end if;
  if tris> 0 then segno<= true;
  else segno<=false;
 end if;
 r<=tris;
end exe_alu;
 
 begin
   
  exe_alu(a,b,op,ris,zero,segno);
 
 end beh;              