library ieee;
use ieee.std_logic_1164.all;

entity SRAM is
  port ( addr : in integer range 0 to 255;
         cs,rw,oe: in std_logic;
         din: in std_logic_vector(31 downto 0);
         dout: out std_logic_vector(31 downto 0);
         ready: out std_logic);
end SRAM;


architecture beh of SRAM is
type memoria is array(0 to 2**8-1) of  std_logic_vector(31 downto 0);
signal mem: memoria;

begin
  process(addr,cs,rw,oe,din,mem)
    begin
    if cs = '0' then -- accesso alla memoria
     if rw= '1'  then --lettura
      if oe = '0' then 
         dout <= mem(addr) after 5 ns;
         ready <='1' after 5 ns;
     else
       dout <= (dout'range => 'Z');
       ready <= '0';
     end if;
     else mem(addr) <= din after 5 ns;--scrittura
          ready <= '1' after 5 ns;
          dout<= (others => 'Z');
     end if;     
   else  dout<= (others => 'Z');
          ready <= '0';
  end if;
 end process;     
end beh;

          
  

         